// gpu/ipc/common/sync_token.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef GPU_IPC_COMMON_SYNC_TOKEN_MOJOM_BLINK_H_
#define GPU_IPC_COMMON_SYNC_TOKEN_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "gpu/ipc/common/sync_token.mojom-shared.h"
#include "gpu/ipc/common/sync_token.mojom-blink-forward.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"




#include "gpu/ipc/common/sync_token_mojom_traits.h"
#include "third_party/blink/public/platform/web_common.h"




namespace WTF {
struct gpu_mojom_internal_CommandBufferNamespace_DataHashFn {
  static unsigned GetHash(const ::gpu::mojom::CommandBufferNamespace& value) {
    using utype = std::underlying_type<::gpu::mojom::CommandBufferNamespace>::type;
    return DefaultHash<utype>::Hash().GetHash(static_cast<utype>(value));
  }
  static bool Equal(const ::gpu::mojom::CommandBufferNamespace& left, const ::gpu::mojom::CommandBufferNamespace& right) {
    return left == right;
  }
  static const bool safe_to_compare_to_empty_or_deleted = true;
};

template <>
struct HashTraits<::gpu::mojom::CommandBufferNamespace>
    : public GenericHashTraits<::gpu::mojom::CommandBufferNamespace> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
  static const bool hasIsEmptyValueFunction = true;
  static bool IsEmptyValue(const ::gpu::mojom::CommandBufferNamespace& value) {
    return value == static_cast<::gpu::mojom::CommandBufferNamespace>(-1000000);
  }
  static void ConstructDeletedValue(::gpu::mojom::CommandBufferNamespace& slot, bool) {
    slot = static_cast<::gpu::mojom::CommandBufferNamespace>(-1000001);
  }
  static bool IsDeletedValue(const ::gpu::mojom::CommandBufferNamespace& value) {
    return value == static_cast<::gpu::mojom::CommandBufferNamespace>(-1000001);
  }
};
}  // namespace WTF

// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace gpu {
namespace mojom {
namespace blink {





class BLINK_PLATFORM_EXPORT SyncToken {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<SyncToken, T>::value>;
  using DataView = SyncTokenDataView;
  using Data_ = internal::SyncToken_Data;

  template <typename... Args>
  static SyncTokenPtr New(Args&&... args) {
    return SyncTokenPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static SyncTokenPtr From(const U& u) {
    return mojo::TypeConverter<SyncTokenPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, SyncToken>::Convert(*this);
  }


  SyncToken();

  SyncToken(
      bool verified_flush,
      CommandBufferNamespace namespace_id,
      uint64_t command_buffer_id,
      uint64_t release_count);

  ~SyncToken();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = SyncTokenPtr>
  SyncTokenPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, SyncToken::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        SyncToken::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        SyncToken::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::SyncToken_UnserializedMessageContext<
            UserType, SyncToken::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<SyncToken::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return SyncToken::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::SyncToken_UnserializedMessageContext<
            UserType, SyncToken::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<SyncToken::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  bool verified_flush;
  
  CommandBufferNamespace namespace_id;
  
  uint64_t command_buffer_id;
  
  uint64_t release_count;

  // Write this structure into |value|. The members are represented as a
  // dictionary |member name|: |member value|. This method does not deal with
  // the dictionary name. The caller is responsible for not calling
  // |AsValueInto| when |value| expects array items (see Array/Dictionary
  // methods of |base::trace_event::TracedValue|).
  //
  // |value| The TracedValue to be written into.
  //
  // Example uses:
  //
  //   // |my_var1, my_var2| are variables with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   value->BeginDictionary("my_var1");
  //   my_var1.AsValueInto(value.get());
  //   value->EndDictionary();
  //   value->BeginDictionary("my_var2");
  //   my_var2.AsValueInto(value.get());
  //   value->EndDictionary();
  //
  //   // |my_var| is a variable with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   my_var.AsValueInto(value.get());
  //   TRACE_EVENT1("test", "test", "my_var", std::move(value));
  //
  // Calling |AsValueInto| on two objects without opening and closing a
  // dictionary for each object is theoretically possible, but strongly
  // discouraged due to potential name collisions:
  //
  //   struct A {
  //     int foo;
  //   };
  //   struct B {
  //     int bar;
  //   };
  //   struct C {
  //     int foo;
  //     int bar;
  //   };
  //   auto value1 = std::make_unique<base::trace_event::TracedValue>();
  //   auto value2 = std::make_unique<base::trace_event::TracedValue>();
  //   A a;
  //   B b;
  //   C c;
  //   // value1 and value2 will be filled with the same information:
  //   a.AsValueInto(value1);
  //   b.AsValueInto(value1);
  //   c.AsValueInto(value2);
  void AsValueInto(base::trace_event::TracedValue* value) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, SyncToken::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, SyncToken::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, SyncToken::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, SyncToken::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}




template <typename StructPtrType>
SyncTokenPtr SyncToken::Clone() const {
  return New(
      mojo::Clone(verified_flush),
      mojo::Clone(namespace_id),
      mojo::Clone(command_buffer_id),
      mojo::Clone(release_count)
  );
}

template <typename T, SyncToken::EnableIfSame<T>*>
bool SyncToken::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->verified_flush, other_struct.verified_flush))
    return false;
  if (!mojo::Equals(this->namespace_id, other_struct.namespace_id))
    return false;
  if (!mojo::Equals(this->command_buffer_id, other_struct.command_buffer_id))
    return false;
  if (!mojo::Equals(this->release_count, other_struct.release_count))
    return false;
  return true;
}

template <typename T, SyncToken::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<>{}(lhs.verified_flush, rhs.verified_flush))
    return true;
  if (std::less<>{}(rhs.verified_flush, lhs.verified_flush))
    return false;
  if (std::less<>{}(lhs.namespace_id, rhs.namespace_id))
    return true;
  if (std::less<>{}(rhs.namespace_id, lhs.namespace_id))
    return false;
  if (std::less<>{}(lhs.command_buffer_id, rhs.command_buffer_id))
    return true;
  if (std::less<>{}(rhs.command_buffer_id, lhs.command_buffer_id))
    return false;
  if (std::less<>{}(lhs.release_count, rhs.release_count))
    return true;
  if (std::less<>{}(rhs.release_count, lhs.release_count))
    return false;
  return false;
}


}  // namespace blink
}  // namespace mojom
}  // namespace gpu

namespace mojo {


template <>
struct BLINK_PLATFORM_EXPORT StructTraits<::gpu::mojom::blink::SyncToken::DataView,
                                         ::gpu::mojom::blink::SyncTokenPtr> {
  static bool IsNull(const ::gpu::mojom::blink::SyncTokenPtr& input) { return !input; }
  static void SetToNull(::gpu::mojom::blink::SyncTokenPtr* output) { output->reset(); }

  static decltype(::gpu::mojom::blink::SyncToken::verified_flush) verified_flush(
      const ::gpu::mojom::blink::SyncTokenPtr& input) {
    return input->verified_flush;
  }

  static decltype(::gpu::mojom::blink::SyncToken::namespace_id) namespace_id(
      const ::gpu::mojom::blink::SyncTokenPtr& input) {
    return input->namespace_id;
  }

  static decltype(::gpu::mojom::blink::SyncToken::command_buffer_id) command_buffer_id(
      const ::gpu::mojom::blink::SyncTokenPtr& input) {
    return input->command_buffer_id;
  }

  static decltype(::gpu::mojom::blink::SyncToken::release_count) release_count(
      const ::gpu::mojom::blink::SyncTokenPtr& input) {
    return input->release_count;
  }

  static bool Read(::gpu::mojom::blink::SyncToken::DataView input, ::gpu::mojom::blink::SyncTokenPtr* output);
};

}  // namespace mojo

#endif  // GPU_IPC_COMMON_SYNC_TOKEN_MOJOM_BLINK_H_