// third_party/blink/public/mojom/input/input_event.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "third_party/blink/public/mojom/input/input_event.mojom-shared.h"

#include <utility>

#include "base/stl_util.h"  // for base::size()
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"

#include "third_party/blink/public/mojom/input/input_event.mojom-params-data.h"
namespace blink {
namespace mojom {

std::ostream& operator<<(std::ostream& os, Button value) {
  switch(value) {
    case Button::kNoButton:
      return os << "Button::kNoButton";
    case Button::kLeft:
      return os << "Button::kLeft";
    case Button::kMiddle:
      return os << "Button::kMiddle";
    case Button::kRight:
      return os << "Button::{kRight, kBarrel}";
    case Button::kBack:
      return os << "Button::kBack";
    case Button::kForward:
      return os << "Button::kForward";
    case Button::kEraser:
      return os << "Button::kEraser";
    default:
      return os << "Unknown Button value: " << static_cast<int32_t>(value);
  }
}

std::ostream& operator<<(std::ostream& os, DispatchType value) {
  switch(value) {
    case DispatchType::kBlocking:
      return os << "DispatchType::kBlocking";
    case DispatchType::kEventNonBlocking:
      return os << "DispatchType::kEventNonBlocking";
    case DispatchType::kListenersNonBlockingPassive:
      return os << "DispatchType::kListenersNonBlockingPassive";
    case DispatchType::kListenersForcedNonBlockingDueToFling:
      return os << "DispatchType::kListenersForcedNonBlockingDueToFling";
    default:
      return os << "Unknown DispatchType value: " << static_cast<int32_t>(value);
  }
}

std::ostream& operator<<(std::ostream& os, EventType value) {
  switch(value) {
    case EventType::kUndefined:
      return os << "EventType::{kUndefined, kTypeFirst}";
    case EventType::kMouseDown:
      return os << "EventType::{kMouseDown, kMouseTypeFirst}";
    case EventType::kMouseUp:
      return os << "EventType::kMouseUp";
    case EventType::kMouseMove:
      return os << "EventType::kMouseMove";
    case EventType::kMouseEnter:
      return os << "EventType::kMouseEnter";
    case EventType::kMouseLeave:
      return os << "EventType::kMouseLeave";
    case EventType::kContextMenu:
      return os << "EventType::{kContextMenu, kMouseTypeLast}";
    case EventType::kMouseWheel:
      return os << "EventType::kMouseWheel";
    case EventType::kRawKeyDown:
      return os << "EventType::{kRawKeyDown, kKeyboardTypeFirst}";
    case EventType::kKeyDown:
      return os << "EventType::kKeyDown";
    case EventType::kKeyUp:
      return os << "EventType::kKeyUp";
    case EventType::kChar:
      return os << "EventType::{kChar, kKeyboardTypeLast}";
    case EventType::kGestureScrollBegin:
      return os << "EventType::{kGestureScrollBegin, kGestureTypeFirst}";
    case EventType::kGestureScrollEnd:
      return os << "EventType::kGestureScrollEnd";
    case EventType::kGestureScrollUpdate:
      return os << "EventType::kGestureScrollUpdate";
    case EventType::kGestureFlingStart:
      return os << "EventType::kGestureFlingStart";
    case EventType::kGestureFlingCancel:
      return os << "EventType::kGestureFlingCancel";
    case EventType::kGesturePinchBegin:
      return os << "EventType::{kGesturePinchBegin, kGesturePinchTypeFirst}";
    case EventType::kGesturePinchEnd:
      return os << "EventType::kGesturePinchEnd";
    case EventType::kGesturePinchUpdate:
      return os << "EventType::{kGesturePinchUpdate, kGesturePinchTypeLast}";
    case EventType::kGestureTapDown:
      return os << "EventType::kGestureTapDown";
    case EventType::kGestureShowPress:
      return os << "EventType::kGestureShowPress";
    case EventType::kGestureTap:
      return os << "EventType::kGestureTap";
    case EventType::kGestureTapCancel:
      return os << "EventType::kGestureTapCancel";
    case EventType::kGestureLongPress:
      return os << "EventType::kGestureLongPress";
    case EventType::kGestureLongTap:
      return os << "EventType::kGestureLongTap";
    case EventType::kGestureTwoFingerTap:
      return os << "EventType::kGestureTwoFingerTap";
    case EventType::kGestureTapUnconfirmed:
      return os << "EventType::kGestureTapUnconfirmed";
    case EventType::kGestureDoubleTap:
      return os << "EventType::{kGestureDoubleTap, kGestureTypeLast}";
    case EventType::kTouchStart:
      return os << "EventType::{kTouchStart, kTouchTypeFirst}";
    case EventType::kTouchMove:
      return os << "EventType::kTouchMove";
    case EventType::kTouchEnd:
      return os << "EventType::kTouchEnd";
    case EventType::kTouchCancel:
      return os << "EventType::kTouchCancel";
    case EventType::kTouchScrollStarted:
      return os << "EventType::{kTouchScrollStarted, kTouchTypeLast}";
    case EventType::kPointerDown:
      return os << "EventType::{kPointerDown, kPointerTypeFirst}";
    case EventType::kPointerUp:
      return os << "EventType::kPointerUp";
    case EventType::kPointerMove:
      return os << "EventType::kPointerMove";
    case EventType::kPointerRawUpdate:
      return os << "EventType::kPointerRawUpdate";
    case EventType::kPointerCancel:
      return os << "EventType::kPointerCancel";
    case EventType::kPointerCausedUaAction:
      return os << "EventType::{kPointerCausedUaAction, kPointerTypeLast, kTypeLast}";
    default:
      return os << "Unknown EventType value: " << static_cast<int32_t>(value);
  }
}

namespace internal {

}  // namespace internal
}  // namespace mojom
}  // namespace blink