// ui/accessibility/mojom/ax_assistant_structure.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_ACCESSIBILITY_MOJOM_AX_ASSISTANT_STRUCTURE_MOJOM_BLINK_H_
#define UI_ACCESSIBILITY_MOJOM_AX_ASSISTANT_STRUCTURE_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "ui/accessibility/mojom/ax_assistant_structure.mojom-shared.h"
#include "ui/accessibility/mojom/ax_assistant_structure.mojom-blink-forward.h"
#include "mojo/public/mojom/base/string16.mojom-blink.h"
#include "ui/gfx/geometry/mojom/geometry.mojom-blink.h"
#include "ui/gfx/range/mojom/range.mojom-blink.h"
#include "url/mojom/url.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"







// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace ax {
namespace mojom {
namespace blink {











class  AssistantTree {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AssistantTree, T>::value>;
  using DataView = AssistantTreeDataView;
  using Data_ = internal::AssistantTree_Data;

  template <typename... Args>
  static AssistantTreePtr New(Args&&... args) {
    return AssistantTreePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AssistantTreePtr From(const U& u) {
    return mojo::TypeConverter<AssistantTreePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AssistantTree>::Convert(*this);
  }


  AssistantTree();

  explicit AssistantTree(
      WTF::Vector<AssistantNodePtr> nodes);

  ~AssistantTree();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AssistantTreePtr>
  AssistantTreePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AssistantTree::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AssistantTree::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AssistantTree::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AssistantTree_UnserializedMessageContext<
            UserType, AssistantTree::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<AssistantTree::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return AssistantTree::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AssistantTree_UnserializedMessageContext<
            UserType, AssistantTree::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AssistantTree::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  WTF::Vector<AssistantNodePtr> nodes;

  // Write this structure into |value|. The members are represented as a
  // dictionary |member name|: |member value|. This method does not deal with
  // the dictionary name. The caller is responsible for not calling
  // |AsValueInto| when |value| expects array items (see Array/Dictionary
  // methods of |base::trace_event::TracedValue|).
  //
  // |value| The TracedValue to be written into.
  //
  // Example uses:
  //
  //   // |my_var1, my_var2| are variables with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   value->BeginDictionary("my_var1");
  //   my_var1.AsValueInto(value.get());
  //   value->EndDictionary();
  //   value->BeginDictionary("my_var2");
  //   my_var2.AsValueInto(value.get());
  //   value->EndDictionary();
  //
  //   // |my_var| is a variable with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   my_var.AsValueInto(value.get());
  //   TRACE_EVENT1("test", "test", "my_var", std::move(value));
  //
  // Calling |AsValueInto| on two objects without opening and closing a
  // dictionary for each object is theoretically possible, but strongly
  // discouraged due to potential name collisions:
  //
  //   struct A {
  //     int foo;
  //   };
  //   struct B {
  //     int bar;
  //   };
  //   struct C {
  //     int foo;
  //     int bar;
  //   };
  //   auto value1 = std::make_unique<base::trace_event::TracedValue>();
  //   auto value2 = std::make_unique<base::trace_event::TracedValue>();
  //   A a;
  //   B b;
  //   C c;
  //   // value1 and value2 will be filled with the same information:
  //   a.AsValueInto(value1);
  //   b.AsValueInto(value1);
  //   c.AsValueInto(value2);
  void AsValueInto(base::trace_event::TracedValue* value) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(AssistantTree);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AssistantTree::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AssistantTree::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AssistantTree::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AssistantTree::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  AssistantNode {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AssistantNode, T>::value>;
  using DataView = AssistantNodeDataView;
  using Data_ = internal::AssistantNode_Data;

  template <typename... Args>
  static AssistantNodePtr New(Args&&... args) {
    return AssistantNodePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AssistantNodePtr From(const U& u) {
    return mojo::TypeConverter<AssistantNodePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AssistantNode>::Convert(*this);
  }


  AssistantNode();

  AssistantNode(
      WTF::Vector<int32_t> children_indices,
      const ::gfx::Rect& rect,
      const ::WTF::String& text,
      float text_size,
      uint32_t color,
      uint32_t bgcolor,
      bool bold,
      bool italic,
      bool underline,
      bool line_through,
      const base::Optional<::gfx::Range>& selection,
      const WTF::String& class_name,
      const WTF::String& role);

  ~AssistantNode();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AssistantNodePtr>
  AssistantNodePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AssistantNode::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AssistantNode::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AssistantNode::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AssistantNode_UnserializedMessageContext<
            UserType, AssistantNode::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<AssistantNode::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return AssistantNode::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AssistantNode_UnserializedMessageContext<
            UserType, AssistantNode::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AssistantNode::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  WTF::Vector<int32_t> children_indices;
  
  ::gfx::Rect rect;
  
  ::WTF::String text;
  
  float text_size;
  
  uint32_t color;
  
  uint32_t bgcolor;
  
  bool bold;
  
  bool italic;
  
  bool underline;
  
  bool line_through;
  
  base::Optional<::gfx::Range> selection;
  
  WTF::String class_name;
  
  WTF::String role;

  // Write this structure into |value|. The members are represented as a
  // dictionary |member name|: |member value|. This method does not deal with
  // the dictionary name. The caller is responsible for not calling
  // |AsValueInto| when |value| expects array items (see Array/Dictionary
  // methods of |base::trace_event::TracedValue|).
  //
  // |value| The TracedValue to be written into.
  //
  // Example uses:
  //
  //   // |my_var1, my_var2| are variables with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   value->BeginDictionary("my_var1");
  //   my_var1.AsValueInto(value.get());
  //   value->EndDictionary();
  //   value->BeginDictionary("my_var2");
  //   my_var2.AsValueInto(value.get());
  //   value->EndDictionary();
  //
  //   // |my_var| is a variable with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   my_var.AsValueInto(value.get());
  //   TRACE_EVENT1("test", "test", "my_var", std::move(value));
  //
  // Calling |AsValueInto| on two objects without opening and closing a
  // dictionary for each object is theoretically possible, but strongly
  // discouraged due to potential name collisions:
  //
  //   struct A {
  //     int foo;
  //   };
  //   struct B {
  //     int bar;
  //   };
  //   struct C {
  //     int foo;
  //     int bar;
  //   };
  //   auto value1 = std::make_unique<base::trace_event::TracedValue>();
  //   auto value2 = std::make_unique<base::trace_event::TracedValue>();
  //   A a;
  //   B b;
  //   C c;
  //   // value1 and value2 will be filled with the same information:
  //   a.AsValueInto(value1);
  //   b.AsValueInto(value1);
  //   c.AsValueInto(value2);
  void AsValueInto(base::trace_event::TracedValue* value) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AssistantNode::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AssistantNode::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AssistantNode::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AssistantNode::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  AssistantExtra {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AssistantExtra, T>::value>;
  using DataView = AssistantExtraDataView;
  using Data_ = internal::AssistantExtra_Data;

  template <typename... Args>
  static AssistantExtraPtr New(Args&&... args) {
    return AssistantExtraPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AssistantExtraPtr From(const U& u) {
    return mojo::TypeConverter<AssistantExtraPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AssistantExtra>::Convert(*this);
  }


  AssistantExtra();

  AssistantExtra(
      const ::blink::KURL& url,
      const ::gfx::Rect& bounds_pixel,
      const ::WTF::String& title);

  ~AssistantExtra();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AssistantExtraPtr>
  AssistantExtraPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AssistantExtra::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AssistantExtra::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AssistantExtra::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AssistantExtra_UnserializedMessageContext<
            UserType, AssistantExtra::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<AssistantExtra::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return AssistantExtra::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AssistantExtra_UnserializedMessageContext<
            UserType, AssistantExtra::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AssistantExtra::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ::blink::KURL url;
  
  ::gfx::Rect bounds_pixel;
  
  ::WTF::String title;

  // Write this structure into |value|. The members are represented as a
  // dictionary |member name|: |member value|. This method does not deal with
  // the dictionary name. The caller is responsible for not calling
  // |AsValueInto| when |value| expects array items (see Array/Dictionary
  // methods of |base::trace_event::TracedValue|).
  //
  // |value| The TracedValue to be written into.
  //
  // Example uses:
  //
  //   // |my_var1, my_var2| are variables with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   value->BeginDictionary("my_var1");
  //   my_var1.AsValueInto(value.get());
  //   value->EndDictionary();
  //   value->BeginDictionary("my_var2");
  //   my_var2.AsValueInto(value.get());
  //   value->EndDictionary();
  //
  //   // |my_var| is a variable with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   my_var.AsValueInto(value.get());
  //   TRACE_EVENT1("test", "test", "my_var", std::move(value));
  //
  // Calling |AsValueInto| on two objects without opening and closing a
  // dictionary for each object is theoretically possible, but strongly
  // discouraged due to potential name collisions:
  //
  //   struct A {
  //     int foo;
  //   };
  //   struct B {
  //     int bar;
  //   };
  //   struct C {
  //     int foo;
  //     int bar;
  //   };
  //   auto value1 = std::make_unique<base::trace_event::TracedValue>();
  //   auto value2 = std::make_unique<base::trace_event::TracedValue>();
  //   A a;
  //   B b;
  //   C c;
  //   // value1 and value2 will be filled with the same information:
  //   a.AsValueInto(value1);
  //   b.AsValueInto(value1);
  //   c.AsValueInto(value2);
  void AsValueInto(base::trace_event::TracedValue* value) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AssistantExtra::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AssistantExtra::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AssistantExtra::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AssistantExtra::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  AssistantStructure {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AssistantStructure, T>::value>;
  using DataView = AssistantStructureDataView;
  using Data_ = internal::AssistantStructure_Data;

  template <typename... Args>
  static AssistantStructurePtr New(Args&&... args) {
    return AssistantStructurePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AssistantStructurePtr From(const U& u) {
    return mojo::TypeConverter<AssistantStructurePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AssistantStructure>::Convert(*this);
  }


  AssistantStructure();

  AssistantStructure(
      AssistantTreePtr assistant_tree,
      AssistantExtraPtr assistant_extra);

  ~AssistantStructure();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AssistantStructurePtr>
  AssistantStructurePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AssistantStructure::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AssistantStructure::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AssistantStructure::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AssistantStructure_UnserializedMessageContext<
            UserType, AssistantStructure::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<AssistantStructure::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return AssistantStructure::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AssistantStructure_UnserializedMessageContext<
            UserType, AssistantStructure::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AssistantStructure::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  AssistantTreePtr assistant_tree;
  
  AssistantExtraPtr assistant_extra;

  // Write this structure into |value|. The members are represented as a
  // dictionary |member name|: |member value|. This method does not deal with
  // the dictionary name. The caller is responsible for not calling
  // |AsValueInto| when |value| expects array items (see Array/Dictionary
  // methods of |base::trace_event::TracedValue|).
  //
  // |value| The TracedValue to be written into.
  //
  // Example uses:
  //
  //   // |my_var1, my_var2| are variables with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   value->BeginDictionary("my_var1");
  //   my_var1.AsValueInto(value.get());
  //   value->EndDictionary();
  //   value->BeginDictionary("my_var2");
  //   my_var2.AsValueInto(value.get());
  //   value->EndDictionary();
  //
  //   // |my_var| is a variable with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   my_var.AsValueInto(value.get());
  //   TRACE_EVENT1("test", "test", "my_var", std::move(value));
  //
  // Calling |AsValueInto| on two objects without opening and closing a
  // dictionary for each object is theoretically possible, but strongly
  // discouraged due to potential name collisions:
  //
  //   struct A {
  //     int foo;
  //   };
  //   struct B {
  //     int bar;
  //   };
  //   struct C {
  //     int foo;
  //     int bar;
  //   };
  //   auto value1 = std::make_unique<base::trace_event::TracedValue>();
  //   auto value2 = std::make_unique<base::trace_event::TracedValue>();
  //   A a;
  //   B b;
  //   C c;
  //   // value1 and value2 will be filled with the same information:
  //   a.AsValueInto(value1);
  //   b.AsValueInto(value1);
  //   c.AsValueInto(value2);
  void AsValueInto(base::trace_event::TracedValue* value) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(AssistantStructure);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AssistantStructure::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AssistantStructure::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AssistantStructure::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AssistantStructure::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
AssistantTreePtr AssistantTree::Clone() const {
  return New(
      mojo::Clone(nodes)
  );
}

template <typename T, AssistantTree::EnableIfSame<T>*>
bool AssistantTree::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->nodes, other_struct.nodes))
    return false;
  return true;
}

template <typename T, AssistantTree::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<>{}(lhs.nodes, rhs.nodes))
    return true;
  if (std::less<>{}(rhs.nodes, lhs.nodes))
    return false;
  return false;
}
template <typename StructPtrType>
AssistantNodePtr AssistantNode::Clone() const {
  return New(
      mojo::Clone(children_indices),
      mojo::Clone(rect),
      mojo::Clone(text),
      mojo::Clone(text_size),
      mojo::Clone(color),
      mojo::Clone(bgcolor),
      mojo::Clone(bold),
      mojo::Clone(italic),
      mojo::Clone(underline),
      mojo::Clone(line_through),
      mojo::Clone(selection),
      mojo::Clone(class_name),
      mojo::Clone(role)
  );
}

template <typename T, AssistantNode::EnableIfSame<T>*>
bool AssistantNode::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->children_indices, other_struct.children_indices))
    return false;
  if (!mojo::Equals(this->rect, other_struct.rect))
    return false;
  if (!mojo::Equals(this->text, other_struct.text))
    return false;
  if (!mojo::Equals(this->text_size, other_struct.text_size))
    return false;
  if (!mojo::Equals(this->color, other_struct.color))
    return false;
  if (!mojo::Equals(this->bgcolor, other_struct.bgcolor))
    return false;
  if (!mojo::Equals(this->bold, other_struct.bold))
    return false;
  if (!mojo::Equals(this->italic, other_struct.italic))
    return false;
  if (!mojo::Equals(this->underline, other_struct.underline))
    return false;
  if (!mojo::Equals(this->line_through, other_struct.line_through))
    return false;
  if (!mojo::Equals(this->selection, other_struct.selection))
    return false;
  if (!mojo::Equals(this->class_name, other_struct.class_name))
    return false;
  if (!mojo::Equals(this->role, other_struct.role))
    return false;
  return true;
}

template <typename T, AssistantNode::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<>{}(lhs.children_indices, rhs.children_indices))
    return true;
  if (std::less<>{}(rhs.children_indices, lhs.children_indices))
    return false;
  if (std::less<>{}(lhs.rect, rhs.rect))
    return true;
  if (std::less<>{}(rhs.rect, lhs.rect))
    return false;
  if (std::less<>{}(lhs.text, rhs.text))
    return true;
  if (std::less<>{}(rhs.text, lhs.text))
    return false;
  if (std::less<>{}(lhs.text_size, rhs.text_size))
    return true;
  if (std::less<>{}(rhs.text_size, lhs.text_size))
    return false;
  if (std::less<>{}(lhs.color, rhs.color))
    return true;
  if (std::less<>{}(rhs.color, lhs.color))
    return false;
  if (std::less<>{}(lhs.bgcolor, rhs.bgcolor))
    return true;
  if (std::less<>{}(rhs.bgcolor, lhs.bgcolor))
    return false;
  if (std::less<>{}(lhs.bold, rhs.bold))
    return true;
  if (std::less<>{}(rhs.bold, lhs.bold))
    return false;
  if (std::less<>{}(lhs.italic, rhs.italic))
    return true;
  if (std::less<>{}(rhs.italic, lhs.italic))
    return false;
  if (std::less<>{}(lhs.underline, rhs.underline))
    return true;
  if (std::less<>{}(rhs.underline, lhs.underline))
    return false;
  if (std::less<>{}(lhs.line_through, rhs.line_through))
    return true;
  if (std::less<>{}(rhs.line_through, lhs.line_through))
    return false;
  if (std::less<>{}(lhs.selection, rhs.selection))
    return true;
  if (std::less<>{}(rhs.selection, lhs.selection))
    return false;
  if (std::less<>{}(lhs.class_name, rhs.class_name))
    return true;
  if (std::less<>{}(rhs.class_name, lhs.class_name))
    return false;
  if (std::less<>{}(lhs.role, rhs.role))
    return true;
  if (std::less<>{}(rhs.role, lhs.role))
    return false;
  return false;
}
template <typename StructPtrType>
AssistantExtraPtr AssistantExtra::Clone() const {
  return New(
      mojo::Clone(url),
      mojo::Clone(bounds_pixel),
      mojo::Clone(title)
  );
}

template <typename T, AssistantExtra::EnableIfSame<T>*>
bool AssistantExtra::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->url, other_struct.url))
    return false;
  if (!mojo::Equals(this->bounds_pixel, other_struct.bounds_pixel))
    return false;
  if (!mojo::Equals(this->title, other_struct.title))
    return false;
  return true;
}

template <typename T, AssistantExtra::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<>{}(lhs.url, rhs.url))
    return true;
  if (std::less<>{}(rhs.url, lhs.url))
    return false;
  if (std::less<>{}(lhs.bounds_pixel, rhs.bounds_pixel))
    return true;
  if (std::less<>{}(rhs.bounds_pixel, lhs.bounds_pixel))
    return false;
  if (std::less<>{}(lhs.title, rhs.title))
    return true;
  if (std::less<>{}(rhs.title, lhs.title))
    return false;
  return false;
}
template <typename StructPtrType>
AssistantStructurePtr AssistantStructure::Clone() const {
  return New(
      mojo::Clone(assistant_tree),
      mojo::Clone(assistant_extra)
  );
}

template <typename T, AssistantStructure::EnableIfSame<T>*>
bool AssistantStructure::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->assistant_tree, other_struct.assistant_tree))
    return false;
  if (!mojo::Equals(this->assistant_extra, other_struct.assistant_extra))
    return false;
  return true;
}

template <typename T, AssistantStructure::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<>{}(lhs.assistant_tree, rhs.assistant_tree))
    return true;
  if (std::less<>{}(rhs.assistant_tree, lhs.assistant_tree))
    return false;
  if (std::less<>{}(lhs.assistant_extra, rhs.assistant_extra))
    return true;
  if (std::less<>{}(rhs.assistant_extra, lhs.assistant_extra))
    return false;
  return false;
}


}  // namespace blink
}  // namespace mojom
}  // namespace ax

namespace mojo {


template <>
struct  StructTraits<::ax::mojom::blink::AssistantTree::DataView,
                                         ::ax::mojom::blink::AssistantTreePtr> {
  static bool IsNull(const ::ax::mojom::blink::AssistantTreePtr& input) { return !input; }
  static void SetToNull(::ax::mojom::blink::AssistantTreePtr* output) { output->reset(); }

  static const decltype(::ax::mojom::blink::AssistantTree::nodes)& nodes(
      const ::ax::mojom::blink::AssistantTreePtr& input) {
    return input->nodes;
  }

  static bool Read(::ax::mojom::blink::AssistantTree::DataView input, ::ax::mojom::blink::AssistantTreePtr* output);
};


template <>
struct  StructTraits<::ax::mojom::blink::AssistantNode::DataView,
                                         ::ax::mojom::blink::AssistantNodePtr> {
  static bool IsNull(const ::ax::mojom::blink::AssistantNodePtr& input) { return !input; }
  static void SetToNull(::ax::mojom::blink::AssistantNodePtr* output) { output->reset(); }

  static const decltype(::ax::mojom::blink::AssistantNode::children_indices)& children_indices(
      const ::ax::mojom::blink::AssistantNodePtr& input) {
    return input->children_indices;
  }

  static const decltype(::ax::mojom::blink::AssistantNode::rect)& rect(
      const ::ax::mojom::blink::AssistantNodePtr& input) {
    return input->rect;
  }

  static const decltype(::ax::mojom::blink::AssistantNode::text)& text(
      const ::ax::mojom::blink::AssistantNodePtr& input) {
    return input->text;
  }

  static decltype(::ax::mojom::blink::AssistantNode::text_size) text_size(
      const ::ax::mojom::blink::AssistantNodePtr& input) {
    return input->text_size;
  }

  static decltype(::ax::mojom::blink::AssistantNode::color) color(
      const ::ax::mojom::blink::AssistantNodePtr& input) {
    return input->color;
  }

  static decltype(::ax::mojom::blink::AssistantNode::bgcolor) bgcolor(
      const ::ax::mojom::blink::AssistantNodePtr& input) {
    return input->bgcolor;
  }

  static decltype(::ax::mojom::blink::AssistantNode::bold) bold(
      const ::ax::mojom::blink::AssistantNodePtr& input) {
    return input->bold;
  }

  static decltype(::ax::mojom::blink::AssistantNode::italic) italic(
      const ::ax::mojom::blink::AssistantNodePtr& input) {
    return input->italic;
  }

  static decltype(::ax::mojom::blink::AssistantNode::underline) underline(
      const ::ax::mojom::blink::AssistantNodePtr& input) {
    return input->underline;
  }

  static decltype(::ax::mojom::blink::AssistantNode::line_through) line_through(
      const ::ax::mojom::blink::AssistantNodePtr& input) {
    return input->line_through;
  }

  static const decltype(::ax::mojom::blink::AssistantNode::selection)& selection(
      const ::ax::mojom::blink::AssistantNodePtr& input) {
    return input->selection;
  }

  static const decltype(::ax::mojom::blink::AssistantNode::class_name)& class_name(
      const ::ax::mojom::blink::AssistantNodePtr& input) {
    return input->class_name;
  }

  static const decltype(::ax::mojom::blink::AssistantNode::role)& role(
      const ::ax::mojom::blink::AssistantNodePtr& input) {
    return input->role;
  }

  static bool Read(::ax::mojom::blink::AssistantNode::DataView input, ::ax::mojom::blink::AssistantNodePtr* output);
};


template <>
struct  StructTraits<::ax::mojom::blink::AssistantExtra::DataView,
                                         ::ax::mojom::blink::AssistantExtraPtr> {
  static bool IsNull(const ::ax::mojom::blink::AssistantExtraPtr& input) { return !input; }
  static void SetToNull(::ax::mojom::blink::AssistantExtraPtr* output) { output->reset(); }

  static const decltype(::ax::mojom::blink::AssistantExtra::url)& url(
      const ::ax::mojom::blink::AssistantExtraPtr& input) {
    return input->url;
  }

  static const decltype(::ax::mojom::blink::AssistantExtra::bounds_pixel)& bounds_pixel(
      const ::ax::mojom::blink::AssistantExtraPtr& input) {
    return input->bounds_pixel;
  }

  static const decltype(::ax::mojom::blink::AssistantExtra::title)& title(
      const ::ax::mojom::blink::AssistantExtraPtr& input) {
    return input->title;
  }

  static bool Read(::ax::mojom::blink::AssistantExtra::DataView input, ::ax::mojom::blink::AssistantExtraPtr* output);
};


template <>
struct  StructTraits<::ax::mojom::blink::AssistantStructure::DataView,
                                         ::ax::mojom::blink::AssistantStructurePtr> {
  static bool IsNull(const ::ax::mojom::blink::AssistantStructurePtr& input) { return !input; }
  static void SetToNull(::ax::mojom::blink::AssistantStructurePtr* output) { output->reset(); }

  static const decltype(::ax::mojom::blink::AssistantStructure::assistant_tree)& assistant_tree(
      const ::ax::mojom::blink::AssistantStructurePtr& input) {
    return input->assistant_tree;
  }

  static const decltype(::ax::mojom::blink::AssistantStructure::assistant_extra)& assistant_extra(
      const ::ax::mojom::blink::AssistantStructurePtr& input) {
    return input->assistant_extra;
  }

  static bool Read(::ax::mojom::blink::AssistantStructure::DataView input, ::ax::mojom::blink::AssistantStructurePtr* output);
};

}  // namespace mojo

#endif  // UI_ACCESSIBILITY_MOJOM_AX_ASSISTANT_STRUCTURE_MOJOM_BLINK_H_